ompi/mca/pml/ob1/pml_ob1_sendreq.h File Reference.TH "ompi/mca/pml/ob1/pml_ob1_sendreq.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/pml/ob1/pml_ob1_sendreq.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'mca/btl/btl.h'\fP
.br
\fC#include 'mca/pml/base/pml_base_sendreq.h'\fP
.br
\fC#include 'mca/mpool/base/base.h'\fP
.br
\fC#include 'pml_ob1_proc.h'\fP
.br
\fC#include 'pml_ob1_comm.h'\fP
.br
\fC#include 'pml_ob1_hdr.h'\fP
.br
\fC#include 'pml_ob1_rdma.h'\fP
.br
\fC#include 'datatype/convertor.h'\fP
.br
\fC#include 'mca/bml/bml.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_ALLOC\fP(comm,dst,sendreq,rc)"
.br
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_INIT\fP(sendreq,buf,count,datatype,dst,tag,comm,sendmode,persistent)"
.br
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_START\fP(sendreq, rc)"
.br
.RI "\fIStart a send request. \fP"
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_MPI_COMPLETE\fP(sendreq)"
.br
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_PML_COMPLETE\fP(sendreq)"
.br
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_ADVANCE\fP(sendreq)"
.br
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_RETURN\fP(sendreq)"
.br
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_SET_BYTES_DELIVERED\fP(sendreq, descriptor, hdrlen)"
.br
.ti -1c
.RI "#define \fBMCA_PML_OB1_SEND_REQUEST_PROCESS_PENDING\fP()"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef mca_pml_ob1_send_request_t \fBmca_pml_ob1_send_request_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (mca_pml_ob1_send_request_t)"
.br
.ti -1c
.RI "int \fBmca_pml_ob1_send_request_start_buffered\fP (mca_pml_ob1_send_request_t *sendreq, mca_bml_base_btl_t *bml_btl, size_t size)"
.br
.RI "\fIStart the specified request. \fP"
.ti -1c
.RI "int \fBmca_pml_ob1_send_request_start_copy\fP (mca_pml_ob1_send_request_t *sendreq, mca_bml_base_btl_t *bml_btl, size_t size)"
.br
.RI "\fIBTL requires 'specially' allocated memory. \fP"
.ti -1c
.RI "int \fBmca_pml_ob1_send_request_start_prepare\fP (mca_pml_ob1_send_request_t *sendreq, mca_bml_base_btl_t *bml_btl, size_t size)"
.br
.RI "\fIBTL can send directly from user buffer so allow the BTL to prepare the segment list. \fP"
.ti -1c
.RI "int \fBmca_pml_ob1_send_request_start_rdma\fP (mca_pml_ob1_send_request_t *sendreq, mca_bml_base_btl_t *bml_btl, size_t size)"
.br
.RI "\fIWe have contigous data that is registered - schedule across available nics. \fP"
.ti -1c
.RI "int \fBmca_pml_ob1_send_request_start_rndv\fP (mca_pml_ob1_send_request_t *sendreq, mca_bml_base_btl_t *bml_btl, size_t size, int flags)"
.br
.RI "\fIRendezvous is required. \fP"
.ti -1c
.RI "int \fBmca_pml_ob1_send_request_schedule\fP (mca_pml_ob1_send_request_t *sendreq)"
.br
.RI "\fISchedule additional fragments. \fP"
.ti -1c
.RI "void \fBmca_pml_ob1_match_completion_cache\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *ep, struct \fBmca_btl_base_descriptor_t\fP *descriptor, int status)"
.br
.RI "\fICompletion callback on match header Cache descriptor. \fP"
.ti -1c
.RI "void \fBmca_pml_ob1_match_completion_free\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *ep, struct \fBmca_btl_base_descriptor_t\fP *descriptor, int status)"
.br
.RI "\fICompletion callback on match header Free descriptor. \fP"
.ti -1c
.RI "void \fBmca_pml_ob1_send_request_put\fP (mca_pml_ob1_send_request_t *sendreq, \fBmca_btl_base_module_t\fP *btl, \fBmca_pml_ob1_rdma_hdr_t\fP *hdr)"
.br
.RI "\fIInitiate a put scheduled by the receiver. \fP"
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define MCA_PML_OB1_SEND_REQUEST_ADVANCE(sendreq)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                      \
    bool schedule = false;                                                                \
                                                                                          \
    /* has an acknowledgment been received */                                             \
    if(OPAL_THREAD_ADD32(&sendreq->req_state, 1) == 2) {                                  \
        OPAL_THREAD_LOCK(&ompi_request_lock);                                             \
        if(sendreq->req_bytes_delivered == sendreq->req_send.req_bytes_packed) {          \
            MCA_PML_OB1_SEND_REQUEST_PML_COMPLETE(sendreq);                               \
        } else {                                                                          \
            schedule = true;                                                              \
        }                                                                                 \
        OPAL_THREAD_UNLOCK(&ompi_request_lock);                                           \
    }                                                                                     \
                                                                                          \
    /* additional data to schedule */                                                     \
    if(schedule == true) {                                                                \
        mca_pml_ob1_send_request_schedule(sendreq);                                       \
    }                                                                                     \
} while (0)
.fi
.SS "#define MCA_PML_OB1_SEND_REQUEST_ALLOC(comm, dst, sendreq, rc)"
.PP
\fBValue:\fP
.PP
.nf
{                                                                          \
    ompi_proc_t *proc =                                                    \
         comm->c_pml_procs[dst]->proc_ompi;                                \
    opal_list_item_t* item;                                                \
                                                                           \
    if(NULL == proc) {                                                     \
        rc = OMPI_ERR_OUT_OF_RESOURCE;                                     \
    } else {                                                               \
        rc = OMPI_SUCCESS;                                                 \
        OMPI_FREE_LIST_WAIT(&mca_pml_ob1.send_requests, item, rc);         \
        sendreq = (mca_pml_ob1_send_request_t*)item;                       \
        sendreq->req_proc = proc;                                          \
    }                                                                      \
}
.fi
.SS "#define MCA_PML_OB1_SEND_REQUEST_INIT(sendreq, buf, count, datatype, dst, tag, comm, sendmode, persistent)"
.PP
\fBValue:\fP
.PP
.nf
{                                                                          \
    MCA_PML_BASE_SEND_REQUEST_INIT(&sendreq->req_send,                     \
        buf,                                                               \
        count,                                                             \
        datatype,                                                          \
        dst,                                                               \
        tag,                                                               \
        comm,                                                              \
        sendmode,                                                          \
        persistent);                                                       \
}
.fi
.SS "#define MCA_PML_OB1_SEND_REQUEST_MPI_COMPLETE(sendreq)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                      \
   (sendreq)->req_send.req_base.req_ompi.req_status.MPI_SOURCE =                          \
       (sendreq)->req_send.req_base.req_comm->c_my_rank;                                  \
   (sendreq)->req_send.req_base.req_ompi.req_status.MPI_TAG =                             \
        (sendreq)->req_send.req_base.req_tag;                                             \
   (sendreq)->req_send.req_base.req_ompi.req_status.MPI_ERROR = OMPI_SUCCESS;             \
   (sendreq)->req_send.req_base.req_ompi.req_status._count =                              \
        (sendreq)->req_send.req_bytes_packed;                                             \
   (sendreq)->req_send.req_base.req_ompi.req_complete = true;                             \
   ompi_request_completed++;                                                              \
   if(ompi_request_waiting) {                                                             \
       opal_condition_broadcast(&ompi_request_cond);                                      \
   }                                                                                      \
} while(0)
.fi
.SS "#define MCA_PML_OB1_SEND_REQUEST_PROCESS_PENDING()"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                  \
    /* advance pending requests */                                    \
    while(opal_list_get_size(&mca_pml_ob1.send_pending)) {            \
        mca_pml_ob1_send_request_t* sendreq;                          \
        OPAL_THREAD_LOCK(&mca_pml_ob1.lock);                          \
        sendreq = (mca_pml_ob1_send_request_t*)                       \
            opal_list_remove_first(&mca_pml_ob1.send_pending);        \
        OPAL_THREAD_UNLOCK(&mca_pml_ob1.lock);                        \
        if(NULL == sendreq)                                           \
            break;                                                    \
        mca_pml_ob1_send_request_schedule(sendreq);                   \
    }                                                                 \
} while (0)
.fi
.SS "#define MCA_PML_OB1_SEND_REQUEST_RETURN(sendreq)"
.PP
\fBValue:\fP
.PP
.nf
{                                                                           \
    /*  Let the base handle the reference counts */                         \
    MCA_PML_BASE_SEND_REQUEST_FINI((&(sendreq)->req_send));                 \
    OMPI_FREE_LIST_RETURN(                                                  \
        &mca_pml_ob1.send_requests, (opal_list_item_t*)sendreq);            \
}
.fi
.SS "#define MCA_PML_OB1_SEND_REQUEST_SET_BYTES_DELIVERED(sendreq, descriptor, hdrlen)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                \
   size_t i;                                                                        \
   mca_btl_base_segment_t* segments = descriptor->des_src;                          \
                                                                                    \
   for(i=0; i<descriptor->des_src_cnt; i++) {                                       \
       sendreq->req_bytes_delivered += segments[i].seg_len;                         \
   }                                                                                \
   sendreq->req_bytes_delivered -= hdrlen;                                          \
                                                                                    \
} while(0)
.fi
.SH "Function Documentation"
.PP 
.SS "int mca_pml_ob1_send_request_schedule (mca_pml_ob1_send_request_t * sendreq)"
.PP
Schedule additional fragments. 
.PP
Up to the rdma threshold. If this is a send based protocol, the rdma threshold is the end of the message. Otherwise, schedule fragments up to the threshold to overlap initial registration/setup costs of the rdma. 
.SS "int mca_pml_ob1_send_request_start_copy (mca_pml_ob1_send_request_t * sendreq, mca_bml_base_btl_t * bml_btl, size_t size)"
.PP
BTL requires 'specially' allocated memory. 
.PP
Request a segment that is used for initial hdr and any eager data. 
.SS "int mca_pml_ob1_send_request_start_rndv (mca_pml_ob1_send_request_t * sendreq, mca_bml_base_btl_t * bml_btl, size_t size, int flags)"
.PP
Rendezvous is required. 
.PP
Not doing rdma so eager send up to the btls eager limit. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
